config/routes.rb
Rails.application.routes.draw do

  resources :tickets

  devise_for :users

  devise_scope :user do
    get '/users/sign_out' => 'devise/sessions#destroy'
  end

  root 'tickets#index'

end

app/models/ticket.rb
class Ticket < ActiveRecord::Base

  ORDER_OPTIONS = [
    ["Created", :created_at],
    ["Updated", :updated_at],
    ["Title", :description],
    ["Owner", :owner_id],
    ["User", :user_id ]
  ]

  @@url = ENV['SOCKET_SERVER'] || 'http://127.0.0.1:3001'

  belongs_to :user
  belongs_to :owner, class_name: User

  validates_presence_of :title
  validates_presence_of :description

  validates :user, presence: true
  validates :owner, presence: true

  after_commit :inform_sockets_create, on: :create
  after_commit :inform_sockets_update, on: :update
  after_commit :inform_sockets_destroy, on: :destroy

  def self.search(params)
    text = params[:text]
    oid = params[:owner_id]
    uid = params[:user_id]
    order = params[:order]
    scope = includes(:user, :owner)
    scope = where(user_id: uid) if uid.present?
    scope = scope.where(owner_id: oid) if oid.present?
    scope = scope.where("title LIKE ? OR description LIKE ?", "%#{text}%", "%#{text}%") if text.present?
    scope = scope.order(order) if order.present?
    scope
  end

  def inform_sockets_create 
    inform_sockets(:create) 
  end

  def inform_sockets_update
    inform_sockets(:update)
  end

  def inform_sockets_destroy
    inform_sockets(:destroy)
  end

  def inform_sockets(action)
    begin
      HTTParty.post(@@url, body: { 
        action: action, ticket: {
          id: self.id,
          title: self.title,
          description: self.description,
          owner: owner.email,
          user: user.email
        }
      }.to_json)
    rescue  Exception => exception
      exception
    end
  end

end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :tickets

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

  # Add an after_sign_up path for staff_user
  
  def after_sign_in_path_for(user)
    tickets_path
  end

  def after_sign_up_path_for(user)
    tickets_path
  end

end

app/controllers/tickets_controller.rb
class TicketsController < ApplicationController

  before_action :authenticate_user!

  before_action :set_ticket, only: [:show, :edit, :update, :destroy]

  # GET /tickets
  # GET /tickets.json
  def index
    @tickets = Ticket.search(params)
  end

  # GET /tickets/1
  # GET /tickets/1.json
  def show
  end

  # GET /tickets/new
  def new
    @ticket = Ticket.new
  end

  # GET /tickets/1/edit
  def edit
  end

  # POST /tickets
  # POST /tickets.json
  def create
    @ticket = Ticket.new(ticket_params)

    respond_to do |format|
      if @ticket.save
        format.html { redirect_to @ticket, notice: 'Ticket was successfully created.' }
        format.json { render :show, status: :created, location: @ticket }
      else
        format.html { render :new }
        format.json { render json: @ticket.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tickets/1
  # PATCH/PUT /tickets/1.json
  def update
    respond_to do |format|
      if @ticket.update(ticket_params)
        format.html { redirect_to @ticket, notice: 'Ticket was successfully updated.' }
        format.json { render :show, status: :ok, location: @ticket }
      else
        format.html { render :edit }
        format.json { render json: @ticket.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tickets/1
  # DELETE /tickets/1.json
  def destroy
    @ticket.destroy
    respond_to do |format|
      format.html { redirect_to tickets_url, notice: 'Ticket was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_ticket
      @ticket = Ticket.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def ticket_params
      params.require(:ticket).permit(:title, :description, :owner_id, :user_id)
    end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
end

app/helpers/application_helper.rb
module ApplicationHelper

  def options_for_user_select(selected)
    options_for_select(User.all.collect {|u| [u.email, u.id] }, selected)
  end

  def socket_io_client
    socket_server + "/socket.io/socket.io.js"
  end

  def socket_server
    @socket_server ||= ENV['SOCKET_SERVER'] || "http://localhost:3001"
  end

end

app/helpers/tickets_helper.rb
module TicketsHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TicketTime</title>
    <%= stylesheet_link_tag 'application', media: 'all' %>
    <%= javascript_include_tag 'application' %>
    <%= csrf_meta_tags %>
  </head>
  <body>
    <% if user_signed_in? %>
      <p>
        <%= link_to('Logout', destroy_user_session_path, :method => :delete) %>
      </p>
    <% end %>
    <%= yield %>
  </body>
</html>

app/views/tickets/_form.html.erb
<%= form_for(@ticket) do |f| %>
  <% if @ticket.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@ticket.errors.count, "error") %> prohibited this ticket from being saved:</h2>
      <ul>
      <% @ticket.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :owner %><br>
		<%= f.collection_select :owner_id, User.all, :id, :email %>
	</div>

  <div class="field">
    <%= f.label :user %><br>
		<%= f.collection_select :user_id, User.all, :id, :email %>
	</div>

  <div class="field">
    <%= f.label :title %><br>
    <%= f.text_field :title %>
  </div>
  <div class="field">
    <%= f.label :description %><br>
    <%= f.text_area :description %>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/tickets/edit.html.erb
<h1>Editing Ticket</h1>

<%= render 'form' %>

<%= link_to 'Show', @ticket %> |
<%= link_to 'Back', tickets_path %>

app/views/tickets/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Tickets</h1>

<%= form_tag(tickets_path, method: 'get') do %>
  <table>
    <thead>
      <tr>
        <th>Title/Description</th>
        <th>Owner</th>
        <th>User</th>
        <th>Sort</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td>
          <%= text_field_tag :text, params[:text] %>
        </td>
        <td>
          <%= select_tag(:owner_id, options_for_user_select(params[:owner_id]), { include_blank: 'Any'}) %>
        </td>
        <td>
          <%= select_tag(:user_id, options_for_user_select(params[:user_id]), { include_blank: 'Any'}) %>
        </td>
        <td>
          <%= select_tag(:order, options_for_select(Ticket::ORDER_OPTIONS, params[:order])) %>
        </td>
        <td>
          <%= submit_tag "Search" %>
        </td>
      </tr>
    </tbody>
  </table>
<% end %>

</br>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Description</th>
      <th>Owner</th>
      <th>User</th>
      <th>Created</th>
      <th>Updated</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody id="tickets">
    <% @tickets.each do |ticket| %>
      <tr id="ticket-<%= ticket.id %>">
        <td><%= ticket.title %></td>
        <td><%= ticket.description %></td>
        <td><%= ticket.owner.email %></td>
        <td><%= ticket.user.email %></td>
        <td><%= ticket.created_at %></td>
        <td><%= ticket.updated_at %></td>
        <td><%= link_to 'Show', ticket %></td>
        <td><%= link_to 'Edit', edit_ticket_path(ticket) %></td>
        <td><%= link_to 'Destroy', ticket, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Ticket', new_ticket_path %>

<script>window.socketServer="<%= socket_server %>";</script>
<%= javascript_include_tag 'socketio' %>
<%= javascript_include_tag 'tickets' %>

app/views/tickets/new.html.erb
<h1>New Ticket</h1>

<%= render 'form' %>

<%= link_to 'Back', tickets_path %>

app/views/tickets/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Owner:</strong>
  <%= @ticket.owner.email %>
</p>

<p>
  <strong>User:</strong>
  <%= @ticket.user.email %>
</p>

<p>
  <strong>Title:</strong>
  <%= @ticket.title %>
</p>

<p>
  <strong>Description:</strong>
  <%= @ticket.description %>
</p>

<%= link_to 'Edit', edit_ticket_path(@ticket) %> |
<%= link_to 'Back', tickets_path %>

app/views/welcome/index.html.erb
<h2>Ticket Time</h2>